;		IPXDEMOS.ASM --- SOURCE TO IPXDEMOS.COM
;	      (ALSO NEEDS IPXDEMOR.ASM --- IPXDEMOR.COM)
;
;	THIS PROGRAM SENDS A PACKET TO EVERY STATION ON A NETWORK
;	AND ACROSS ALL BRIDGES OF THE INTERNETWORK.  IF USED IN
;	CONJUNCTION WITH IPXDEMOR.COM IT CAN CAUSE ALL STATIONS
;	ON A NETWORK TO BE REBOOTED FROM ONE COMPUTER.  THE
;	MAIN INSTRUCTIONS AND EXPLANATION OF THE THEORY IS CONTAINED
;	IN IPXDEMOR.ASM.
;
;                                CLAY JONES
;                          (DEVELOPER OF HOT PRINT)

CSEG	SEGMENT	PARA PUBLIC 'code'
	ORG	100h
	ASSUME	CS:CSEG, DS:CSEG

ENTRY	PROC	NEAR
	JMP	GO		; JUMP AROUND DATA PORTION TO THE CODE

RST_SOC	EQU	9997h		; THE SOCKET WE WILL SEND TO

ECB1	DD	0		; EVENT CONTROL BLOCK FOR SENDING
ADDR1	DD	0		; NO SERVICE ROUTINE NEEDED
INUSE1	DB	0
COMPL1	DB	0
SOCKT1	DW	RST_SOC
WK1	DB	16 DUP(0)
IMADR1	DB	6 DUP (0FFh)	; SETTING IMMEDIATE ADDRESS TO FF MEANS 'ALL'
FRG1	DW	1		; ONLY 1 FRAGMENT TO SEND
AD1A	DD	0		; ADDRESS OF FRAGMENT FILLED IN BY CODE
SIZ1A	DB	36,0		; LENGTH IS FIXED AT 36

CHSUM1	DB	0,0		; IPX HEADER FOR SEND PACKET
LEN1	DB	0,0
TC1	DB	0
PT1	DB	0
DST1	DB	0,0,0,0, 6 DUP(0FFh)	; THIS DESTINATION MEANS EVERYONE
	DW	RST_SOC			; ... ON THIS SOCKET WILL RECEIVE
SRC1	DB	10 DUP(0),4,52h		; SOURCE FILLED IN BY IPX

BUFR	DB	50 DUP(0)		; BUFFER IS MEANINGLESS IN THIS CASE

GO:	MOV	BX,0			; FIRST WE OPEN THE SOCKET
	MOV	DX,RST_SOC		; OPEN OUR SPECIFIC SOCKET
	MOV	AL,0			; OPEN IT UNTIL WE TERMINATE
	INT	7Ah			; INT 7A MEANS CALL IPX
	PUSH	DS			; RESET THE ES REGISTER
	POP	ES
	MOV	AX,DS			; PUT DATA SEGMENT INTO AX
	MOV	WORD PTR AD1A+2,AX	; ... THEN PUT IT INTO ECB
	MOV	WORD PTR AD1A,OFFSET CHSUM1	; ALSO SET SEGMENT OFFSET
	LEA	SI,ECB1			; PUT ADDRESS OF ECB INTO SI
	MOV	BX,3			; BX=3 MEANS SEND A PACKET
	INT	7Ah			; CALL IPX
	INT	20h			; EXIT THE PROGRAM
ENTRY	ENDP
CSEG	ENDS
	END	ENTRY

